// ExitMfc.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "ExitMfc.h"
#include "ExitMfcDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExitMfcApp

BEGIN_MESSAGE_MAP(CExitMfcApp, CWinApp)
	//{{AFX_MSG_MAP(CExitMfcApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExitMfcApp construction

CExitMfcApp::CExitMfcApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CExitMfcApp object

CExitMfcApp theApp;


void EnableShutdownPrivileges( void ){

   // Variables...
   HANDLE token;
   TOKEN_PRIVILEGES privileges;

   // Get the current process token handle...
   if( !OpenProcessToken( GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES
                         | TOKEN_QUERY, &token ))
      AfxMessageBox( TEXT( "ERROR: Unable to open process token." ),
                     NULL, MB_OK | MB_ICONERROR );

   // Get the LUID for shutdown privilege...
   LookupPrivilegeValue( NULL, SE_SHUTDOWN_NAME, &privileges.Privileges[ 0 ].Luid );

   // Set parameters for AdjustTokenPrivileges...
   privileges.PrivilegeCount = 1;
   privileges.Privileges[ 0 ].Attributes = SE_PRIVILEGE_ENABLED;

   // Enable shutdown privilege...
   AdjustTokenPrivileges( token, FALSE, &privileges, 0, (PTOKEN_PRIVILEGES)NULL, 0 );
   if( GetLastError() != ERROR_SUCCESS )
      AfxMessageBox( TEXT( "ERROR: Uanble to adjust token privileges." ),
                     NULL, MB_OK | MB_ICONERROR );

}//end function EnableShutdownPrivileges()



BOOL SetPrivilege(
    HANDLE hToken,          // access token handle
    LPCTSTR lpszPrivilege,  // name of privilege to enable/disable
    BOOL bEnablePrivilege   // to enable or disable privilege
    ) 
{
	TOKEN_PRIVILEGES tp;
	LUID luid;

	if ( !LookupPrivilegeValue( 
			  NULL,            // lookup privilege on local system
			  lpszPrivilege,   // privilege to lookup 
			  &luid ) )        // receives LUID of privilege
	{
		 printf("LookupPrivilegeValue error: %u\n", GetLastError() ); 
		 return FALSE; 
	}

	tp.PrivilegeCount = 1;
	tp.Privileges[0].Luid = luid;
	if (bEnablePrivilege)
		 tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	else
		 tp.Privileges[0].Attributes = 0;

	// Enable the privilege or disable all privileges.

	if ( !AdjustTokenPrivileges(
			 hToken, 
			 FALSE, 
			 &tp, 
			 sizeof(TOKEN_PRIVILEGES), 
			 (PTOKEN_PRIVILEGES) NULL, 
			 (PDWORD) NULL) )
	{ 
			printf("AdjustTokenPrivileges error: %u\n", GetLastError() ); 
			return FALSE; 
	} 

	if (GetLastError() == ERROR_NOT_ALL_ASSIGNED)

	{
			printf("The token does not have the specified privilege. \n");
			return FALSE;
	} 

	return TRUE;
}

void CCommandLine::ParseParam( LPCTSTR lpszParam, BOOL bFlag, BOOL bLast ){

   // Check for flags...
   if( bFlag ){
      if( lstrcmpi( lpszParam, TEXT( "LOGOFF" )) == 0 )
         mycommand = LOGOFF;
      else if( lstrcmpi( lpszParam, TEXT( "POWEROFF" )) == 0 )
         mycommand = POWEROFF;
      else if( lstrcmpi( lpszParam, TEXT( "RESTART" )) == 0 )
         mycommand = RESTART;
      else if( lstrcmpi( lpszParam, TEXT( "SHUTDOWN" )) == 0 )
         mycommand = SHUTDOWN;
      else if( lstrcmpi( lpszParam, TEXT( "HIBERNATE" )) == 0 )
         mycommand = HIBERNATE;
   }//end if

}//end function ParseParam();


/////////////////////////////////////////////////////////////////////////////
// CExitMfcApp initialization

BOOL CExitMfcApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.


   CCommandLine cmd;
	cmd.mycommand = NONE;

   	ParseCommandLine(cmd);

		
// rundll32.exe powrprof.dll,SetSuspendState

	EnableShutdownPrivileges();
//	theApp.OpenPro
//	SetPrivilege( , SE_SHUTDOWN_NAME, TRUE);
 
//	if(!InitiateSystemShutdown("","Restarting",8,FALSE,TRUE))
//	theApp.SetPri
//	if(SetPrivilege(NULL,"SeShutdownPrivilege",TRUE))

	  CString str;
	  int err=0;

   switch( cmd.mycommand ){
      case NONE:{
         // Create the main dialog...
//         CLogoffMainDlg dialog;
  //       m_pMainWnd = &dialog;
  //       dialog.DoModal();
			str = "Exit /LOGOFF | /POWEROFF | /RESTART | /SHUTDOWN | /HIBERNATE";
			AfxMessageBox(str);
         }break;
      case LOGOFF:
			if(!::ExitWindowsEx(EWX_LOGOFF|EWX_FORCE,0))
				err= 1;
         break;
      case POWEROFF:
			if(!::ExitWindowsEx(EWX_POWEROFF|EWX_FORCE,0))
				err= 1;
         break;
      case RESTART:
			if(!::ExitWindowsEx(EWX_REBOOT|EWX_FORCE,0))
				err= 1;
         break;
      case SHUTDOWN:
			if(!::ExitWindowsEx(EWX_SHUTDOWN|EWX_FORCE,0))
				err= 1;
		case HIBERNATE:
			if(WinExec("rundll32.exe powrprof.dll,SetSuspendState",SW_HIDE)<32)
				err=1;
   //      logoff.Shutdown();
   }//end switch




  if(err)
  {
	  ::FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,0,GetLastError(),0,str.GetBuffer(256),256,NULL);
//	  str.Format("Error: %d",GetLastError());
	  AfxMessageBox(str);
	}

/* 
	CExitMfcDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}
 */
	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
